#include "project.h"



#define SLEWX 100
#define SLEWY 0

print_bammap(BAMMAP m)
{
  printf("%d %d %f %f\n", m.mx, m.my, m.x, m.y);
}


BAMMAP bosxy_to_bammap(BOSXY x)
{
  BAMMAP m;


  x.x += SLEWX;
  x.y += SLEWY;

  m.mx = 100 * (int) (x.x / 100);
  m.my = 50 * (int) (x.y / 50);

  x.x -= m.mx;
  x.y -= m.my;

  m.x = ((float) x.x) / 100.0;
  m.y = ((float) x.y) / 50.0;

  return m;
}

BOSXY bammap_to_bosxy(BAMMAP m)
{
  BOSXY x;

  x.x = m.mx + (int) (.5 + (100.0 * m.x));
  x.y = m.my + (int) (.5 + (100.0 * m.y));
  x.x -= SLEWX;
  x.y -= SLEWY;

  return x;
}

BAMMAP bosgrid_to_bammap(BOSGRID g)
{
  return bosxy_to_bammap(bosgrid_to_bosxy(g));
}

BOSGRID bammap_to_bosgrid(BAMMAP m)
{
  return bosxy_to_bosgrid(bammap_to_bosxy(m));
}

BOSXY bamxy_neighbour(BOSXY o, int n, int e)
{
  o.x += 100L * (long) n;
  o.y += 50L * (long) e;
  return o;
}

char *bammap_to_filename(BAMMAP m)
{
  char buf[1024];
  sprintf(buf, "%s/0.25/%3d/%3d/%06d.%06d.jpg", getenv("BAMPATH"),
          m.mx / 1000, m.my / 1000, m.mx, m.my);

  return strdup(buf);

}

int bam_same_map(BAMMAP m1, BAMMAP m2)
{
  if (m1.mx != m2.mx)
    return 0;
  if (m1.my != m2.my)
    return 0;
  return 1;
}
