#include "project.h"
#include <math.h>

#define CS 30
#define CE 5

#define PXS ((CS+1)*2)
#define PYS ((CS+1)*2)
#define PXO ((CS+1))
#define PYO ((CS+1))


static int cursor = 0;
static int cx, cy, ch;
Pixmap cursor_pixmap;

void cursor_init()
{
  cursor_pixmap = XCreatePixmap(dpy, win, PXS, PYS, colordepth);
}

void cursor_draw(int x, int y, int h)
{
  int ex, ey, sx, sy;
  float th = (M_PI / 180.f) * (float) h;
  float fx, fy;



  fx = sin(th);
  fy = -cos(th);
  sx = (int) (((float) CS) * fx);
  ex = (int) (((float) CE) * fx);
  sy = (int) (((float) CS) * fy);
  ey = (int) (((float) CE) * fy);

  ex += x;
  ey += y;
  sx += x;
  sy += y;


  XSetForeground(dpy, gc, 0x0);

  XCopyArea(dpy, win, cursor_pixmap, gc, x - PXO, y - PYO, PXS, PYS, 0, 0);

  XDrawLine(dpy, win, gc, x - CS, y, x - CE, y);
  XDrawLine(dpy, win, gc, x + CS, y, x + CE, y);
  XDrawLine(dpy, win, gc, x, y - CS, x, y - CE);
  XDrawLine(dpy, win, gc, x, y + CS, x, y + CE);

  XSetForeground(dpy, gc, 0x13ff);
  XDrawLine(dpy, win, gc, sx, sy, ex, ey);
}

cursor_remove()
{
  XCopyArea(dpy, cursor_pixmap, win, gc, 0, 0, PXS, PYS, cx - PXO,
            cy - PYO);
  cursor = 0;
}


cursor_put(int x, int y, int h)
{
  if (cursor)
    cursor_remove();

  cx = x;
  cy = y;
  ch = h;

  cursor_draw(x, y, h);
  cursor = 1;
}

cursor_redraw()
{
  cursor = 0;
}
