
/* main.c */
Display *dpy;
Window win;
GC gc;
Frame frame;
Canvas canvas;
Panel panel;
Panel_item scale;
Panel_item placeitem;
Panel_item head;
Panel_item mps;
Panel_item mph;
Panel_item alt;
Panel_item gridref;
Panel_item dist;
Panel_item eta;
Panel_item destref;
Panel_item motion_speed;
WGS84 pos;
Places place;
int heading;
void new_pos(void);
float speed_mps;
void update_speeds(float fve, float fvn, float fvu, float a);
float ltdiv;
Notify_value poke_gps(Notify_client client, int fd);
int main(int argc, char *argv[]);
/* ios.c */
int print_iosxy(IOSXY o);
int print_iosgrid(IOSGRID g);
int sprint_iosgrid(char *buf, IOSGRID g);
int print_iosmap(IOSMAP m);
IOSMAP iosxy_to_iosmap(IOSXY x);
IOSXY iosmap_to_iosxy(IOSMAP m);
IOSXY iosgrid_to_iosxy(IOSGRID g);
IOSGRID iosxy_to_iosgrid(IOSXY o);
IOSXY iosxy_neighbour(IOSXY o, int n, int e);
char *iosmap_to_filename(IOSMAP m);
int ios_same_map(IOSMAP m1, IOSMAP m2);
/* bview.c */
void b_canvas_repaint(void);
void b_set_tdiv(float q);
float b_get_size(void);
void b_set_size(float q);
void b_flush_tiles(void);
void b_new_pos(void);
void b_clicked(int x, int y, int move);
/* iview.c */
void i_canvas_repaint(void);
void i_set_tdiv(float q);
float i_get_size(void);
void i_set_size(float q);
void i_flush_tiles(void);
void i_new_pos(void);
void i_clicked(int x, int y, int move);
/* bamview.c */
void bam_canvas_repaint(void);
void bam_set_tdiv(double q);
float bam_get_size(void);
void bam_set_size(float q);
void bam_flush_tiles(void);
void bam_new_pos(void);
void bam_clicked(int x, int y, int move);
/* gps.c */
int state;
unsigned char mdata[10];
unsigned char buf[1024];
int dwc;
int dwp;
FILE *where;
short int put_UI16(unsigned char *ptr, unsigned short int val);
short int put_I16(unsigned char *ptr, short int val);
short int get_I16(char *ptr);
unsigned short int get_UI16(char *ptr);
long int get_I32(char *ptr);
long unsigned int get_UI32(char *ptr);
float get_F32(unsigned char *ptr);
double get_F48(unsigned char *ptr);
int put_F48(unsigned char *ptr, double val);
int put_F32(unsigned char *ptr, float val);
int checksum(unsigned char *ucdata, int len);
char str_chan_buf[1024];
char *str_chan(unsigned char *pkt);
char *str_soh(unsigned char *pkt);
char *str_stat(unsigned char *pkt);
int dtr;
int dtre;
int process_packet(int fd, unsigned short mid, unsigned char *pkt, int len, int type);
int send_message(int fd, int mid, int ack, unsigned char *pkt, int len);
int request_bit(int fd);
int init_gps(int fd, double lat, double lon, float alt);
int process_char(int fd, unsigned char c);
int gps_init(char *dev);
void gps_dispatch(void);
/* bam.c */
int print_bammap(BAMMAP m);
BAMMAP bosxy_to_bammap(BOSXY x);
BOSXY bammap_to_bosxy(BAMMAP m);
BAMMAP bosgrid_to_bammap(BOSGRID g);
BOSGRID bammap_to_bosgrid(BAMMAP m);
BOSXY bamxy_neighbour(BOSXY o, int n, int e);
char *bammap_to_filename(BAMMAP m);
int bam_same_map(BAMMAP m1, BAMMAP m2);
/* bos.c */
int print_bosxy(BOSXY o);
int print_bosgrid(BOSGRID g);
int sprint_bosgrid(char *buf, BOSGRID g);
int print_bosmap(BOSMAP m);
BOSMAP bosgrid_to_bosmap(BOSGRID g);
BOSGRID bosmap_to_bosgrid(BOSMAP m);
BOSXY bosgrid_to_bosxy(BOSGRID g);
BOSGRID bosxy_to_bosgrid(BOSXY o);
BOSXY bosxy_neighbour(BOSXY o, int n, int e);
char *bosmap_to_filename(BOSMAP m);
int bos_same_map(BOSMAP m1, BOSMAP m2);
/* cursor.c */
Pixmap cursor_pixmap;
void cursor_init(void);
void cursor_draw(int x, int y, int h);
int cursor_remove(void);
int cursor_put(int x, int y, int h);
int cursor_redraw(void);
/* color.c */
int colordepth;
void color_init(Frame frame, Display *dpy);
/* paf.c */
WGS84 paf_lookup(Places place, char *qpostcode);
